<html devsite>
  <head>
    <title>View Patches</title>
    <meta name="project_path" value="/_project.yaml" />
    <meta name="book_path" value="/_book.yaml" />
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->

    <p>
      If you want to view all patches to the Android Open Source Project, or
      if you are reviewing or verifying a change, look in the <a
      href="https://www.google.com/url?sa=D&q=https%3A%2F%2Fandroid-review.googlesource.com%2F%23%2Fq%2Fstatus%3Aopen%2BOR%2Bstatus%3Aclosed">
      AOSP Gerrit</a>. For more information on how to find a specific change, see <a
      href="https://gerrit-review.googlesource.com/Documentation/user-search.html">
      Gerrit Code Review - Searching Changes</a>.
    </p>

    <h2 id="reviewing-a-change">Reviewing a change</h2>

      <p>
        If you are assigned to be the <em>Reviewer</em> for a change, you need
        to determine the following:
      </p>

      <ul>
        <li>Does this change fit within this project's stated purpose?</li>
        <li>Is this change valid within the project's existing architecture?
        </li>
        <li>Does this change introduce design flaws that will cause problems in
          the future?</li>
        <li>Does this change follow the best practices that have been
          established for this project?</li>
        <li>Is this change a good way to perform the described function?</li>
        <li>Does this change introduce any security or instability risks?</li>
      </ul>

      <p>
        If you approve of the change, mark it with LGTM ("Looks Good to Me")
        within Gerrit.
      </p>

    <h2 id="verifying-a-change">Verifying a change</h2>

      <p>
        If you are assigned to be the <em>Verifier</em> for a change, you need
        to do the following:
      </p>

      <ul>
        <li>Patch the change into your local client using one of the Download
        commands.</li>
        <li>Build and test the change.</li>
        <li>Within Gerrit select the <strong>Reply</strong> button. This
        brings up a comment box where you can mark the change as
        <em>Verified</em> or not, and add a message explaining what problems
        were identified.</li>
      </ul>

    <h2 id="downloading-changes-from-gerrit">Downloading changes from Gerrit
    </h2>

      <p>
        A submission that has been verified and merged will be downloaded with
        the next <code>repo sync</code>. If you wish to download a specific
        change that has not yet been approved, run
      </p>


      <pre
      class="devsite-terminal devsite-click-to-copy">
repo download <var>TARGET CHANGE</var></pre>

      <p> where <code><var>TARGET</var></code> is the local directory into
        which the change should be downloaded and
        <code><var>CHANGE</var></code> is the change number as listed in
        Gerrit. For more information, see the <a
        href="../develop/repo.html">Repo reference</a>.
      </p>

    <h2 id="how-do-i-become-a-verifier-or-reviewer">How do I become a Verifier
      or Reviewer?</h2>

      <p>
        In short, contribute high-quality code to one or more of the Android
        projects. For details about the different roles in the Android Open
        Source community and who plays them, see <a
        href="../start/roles.html">Project Roles</a>.
      </p>

    <h2 id="diffs-and-comments">Diffs and comments</h2>

      <p>
        To open the details of the change within Gerrit, click on the <em>Id
        number</em> or <em>Subject</em> of a change. To compare the
        established code with the updated code, click the file name under
        <em>Side-by-side diffs</em>.
      </p>

    <h2 id="adding-comments">Adding comments</h2>

      <p>
        Anyone in the community can use Gerrit to add inline comments to code
        submissions. A good comment will be relevant to the line or section of
        code to which it is attached in Gerrit. It might be a short and
        constructive suggestion about how a line of code could be improved, or
        it might be an explanation from the author about why the code makes
        sense the way it is.
      </p>

      <p>
        To add an inline comment, double-click the relevant line of the code
        and write your comment in the text box that opens. When you click
        <strong>Save</strong>, only you can see your comment.
      </p>

      <p>
        To publish your comments so that others using Gerrit will be able to
        see them, click the Publish Comments button. Your comments will be
        emailed to all relevant parties for this change, including the change
        owner, the patch set uploader (if different from the owner), and all
        current reviewers.
      </p>

  </body>

</html>
